git-stash.shon commit Docs: send-email's usage text and man page mention same options (7ecbad9)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless (show | drop | pop ) [<stash>]
   7   or: $dashless apply [--index] [<stash>]
   8   or: $dashless branch <branchname> [<stash>]
   9   or: $dashless [save [--keep-index] [<message>]]
  10   or: $dashless clear"
  11
  12SUBDIRECTORY_OK=Yes
  13OPTIONS_SPEC=
  14. git-sh-setup
  15require_work_tree
  16cd_to_toplevel
  17
  18TMP="$GIT_DIR/.git-stash.$$"
  19trap 'rm -f "$TMP-*"' 0
  20
  21ref_stash=refs/stash
  22
  23no_changes () {
  24        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  25        git diff-files --quiet --ignore-submodules
  26}
  27
  28clear_stash () {
  29        if test $# != 0
  30        then
  31                die "git stash clear with parameters is unimplemented"
  32        fi
  33        if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
  34        then
  35                git update-ref -d $ref_stash $current
  36        fi
  37}
  38
  39create_stash () {
  40        stash_msg="$1"
  41
  42        git update-index -q --refresh
  43        if no_changes
  44        then
  45                exit 0
  46        fi
  47
  48        # state of the base commit
  49        if b_commit=$(git rev-parse --verify HEAD)
  50        then
  51                head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
  52        else
  53                die "You do not have the initial commit yet"
  54        fi
  55
  56        if branch=$(git symbolic-ref -q HEAD)
  57        then
  58                branch=${branch#refs/heads/}
  59        else
  60                branch='(no branch)'
  61        fi
  62        msg=$(printf '%s: %s' "$branch" "$head")
  63
  64        # state of the index
  65        i_tree=$(git write-tree) &&
  66        i_commit=$(printf 'index on %s\n' "$msg" |
  67                git commit-tree $i_tree -p $b_commit) ||
  68                die "Cannot save the current index state"
  69
  70        # state of the working tree
  71        w_tree=$( (
  72                rm -f "$TMP-index" &&
  73                cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
  74                GIT_INDEX_FILE="$TMP-index" &&
  75                export GIT_INDEX_FILE &&
  76                git read-tree -m $i_tree &&
  77                git add -u &&
  78                git write-tree &&
  79                rm -f "$TMP-index"
  80        ) ) ||
  81                die "Cannot save the current worktree state"
  82
  83        # create the stash
  84        if test -z "$stash_msg"
  85        then
  86                stash_msg=$(printf 'WIP on %s' "$msg")
  87        else
  88                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
  89        fi
  90        w_commit=$(printf '%s\n' "$stash_msg" |
  91                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
  92                die "Cannot record working tree state"
  93}
  94
  95save_stash () {
  96        keep_index=
  97        case "$1" in
  98        --keep-index)
  99                keep_index=t
 100                shift
 101        esac
 102
 103        stash_msg="$*"
 104
 105        git update-index -q --refresh
 106        if no_changes
 107        then
 108                echo 'No local changes to save'
 109                exit 0
 110        fi
 111        test -f "$GIT_DIR/logs/$ref_stash" ||
 112                clear_stash || die "Cannot initialize stash"
 113
 114        create_stash "$stash_msg"
 115
 116        # Make sure the reflog for stash is kept.
 117        : >>"$GIT_DIR/logs/$ref_stash"
 118
 119        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
 120                die "Cannot save the current status"
 121        printf 'Saved working directory and index state "%s"\n' "$stash_msg"
 122
 123        git reset --hard
 124
 125        if test -n "$keep_index" && test -n $i_tree
 126        then
 127                git read-tree --reset -u $i_tree
 128        fi
 129}
 130
 131have_stash () {
 132        git rev-parse --verify $ref_stash >/dev/null 2>&1
 133}
 134
 135list_stash () {
 136        have_stash || return 0
 137        git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
 138        sed -n -e 's/^[.0-9a-f]* refs\///p'
 139}
 140
 141show_stash () {
 142        flags=$(git rev-parse --no-revs --flags "$@")
 143        if test -z "$flags"
 144        then
 145                flags=--stat
 146        fi
 147
 148        if test $# = 0
 149        then
 150                set x "$ref_stash@{0}"
 151                shift
 152        fi
 153
 154        s=$(git rev-parse --revs-only --no-flags "$@")
 155
 156        w_commit=$(git rev-parse --verify "$s") &&
 157        b_commit=$(git rev-parse --verify "$s^") &&
 158        git diff $flags $b_commit $w_commit
 159}
 160
 161apply_stash () {
 162        git update-index -q --refresh &&
 163        git diff-files --quiet --ignore-submodules ||
 164                die 'Cannot apply to a dirty working tree, please stage your changes'
 165
 166        unstash_index=
 167        case "$1" in
 168        --index)
 169                unstash_index=t
 170                shift
 171        esac
 172
 173        if test $# = 0
 174        then
 175                set x "$ref_stash@{0}"
 176                shift
 177        fi
 178
 179        # current index state
 180        c_tree=$(git write-tree) ||
 181                die 'Cannot apply a stash in the middle of a merge'
 182
 183        # stash records the work tree, and is a merge between the
 184        # base commit (first parent) and the index tree (second parent).
 185        s=$(git rev-parse --revs-only --no-flags "$@") &&
 186        w_tree=$(git rev-parse --verify "$s:") &&
 187        b_tree=$(git rev-parse --verify "$s^1:") &&
 188        i_tree=$(git rev-parse --verify "$s^2:") ||
 189                die "$*: no valid stashed state found"
 190
 191        unstashed_index_tree=
 192        if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
 193                        test "$c_tree" != "$i_tree"
 194        then
 195                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 196                test $? -ne 0 &&
 197                        die 'Conflicts in index. Try without --index.'
 198                unstashed_index_tree=$(git-write-tree) ||
 199                        die 'Could not save index tree'
 200                git reset
 201        fi
 202
 203        eval "
 204                GITHEAD_$w_tree='Stashed changes' &&
 205                GITHEAD_$c_tree='Updated upstream' &&
 206                GITHEAD_$b_tree='Version stash was based on' &&
 207                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 208        "
 209
 210        if git-merge-recursive $b_tree -- $c_tree $w_tree
 211        then
 212                # No conflict
 213                if test -n "$unstashed_index_tree"
 214                then
 215                        git read-tree "$unstashed_index_tree"
 216                else
 217                        a="$TMP-added" &&
 218                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 219                        git read-tree --reset $c_tree &&
 220                        git update-index --add --stdin <"$a" ||
 221                                die "Cannot unstage modified files"
 222                        rm -f "$a"
 223                fi
 224                git status || :
 225        else
 226                # Merge conflict; keep the exit status from merge-recursive
 227                status=$?
 228                if test -n "$unstash_index"
 229                then
 230                        echo >&2 'Index was not unstashed.'
 231                fi
 232                exit $status
 233        fi
 234}
 235
 236drop_stash () {
 237        have_stash || die 'No stash entries to drop'
 238
 239        if test $# = 0
 240        then
 241                set x "$ref_stash@{0}"
 242                shift
 243        fi
 244        # Verify supplied argument looks like a stash entry
 245        s=$(git rev-parse --revs-only --no-flags "$@") &&
 246        git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
 247        git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
 248        git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
 249                die "$*: not a valid stashed state"
 250
 251        git reflog delete --updateref --rewrite "$@" &&
 252                echo "Dropped $* ($s)" || die "$*: Could not drop stash entry"
 253
 254        # clear_stash if we just dropped the last stash entry
 255        git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
 256}
 257
 258apply_to_branch () {
 259        have_stash || die 'Nothing to apply'
 260
 261        test -n "$1" || die 'No branch name specified'
 262        branch=$1
 263
 264        if test -z "$2"
 265        then
 266                set x "$ref_stash@{0}"
 267        fi
 268        stash=$2
 269
 270        git-checkout -b $branch $stash^ &&
 271        apply_stash --index $stash &&
 272        drop_stash $stash
 273}
 274
 275# Main command set
 276case "$1" in
 277list)
 278        shift
 279        if test $# = 0
 280        then
 281                set x -n 10
 282                shift
 283        fi
 284        list_stash "$@"
 285        ;;
 286show)
 287        shift
 288        show_stash "$@"
 289        ;;
 290save)
 291        shift
 292        save_stash "$@"
 293        ;;
 294apply)
 295        shift
 296        apply_stash "$@"
 297        ;;
 298clear)
 299        shift
 300        clear_stash "$@"
 301        ;;
 302create)
 303        if test $# -gt 0 && test "$1" = create
 304        then
 305                shift
 306        fi
 307        create_stash "$*" && echo "$w_commit"
 308        ;;
 309drop)
 310        shift
 311        drop_stash "$@"
 312        ;;
 313pop)
 314        shift
 315        if apply_stash "$@"
 316        then
 317                test -z "$unstash_index" || shift
 318                drop_stash "$@"
 319        fi
 320        ;;
 321branch)
 322        shift
 323        apply_to_branch "$@"
 324        ;;
 325*)
 326        if test $# -eq 0
 327        then
 328                save_stash &&
 329                echo '(To restore them type "git stash apply")'
 330        else
 331                usage
 332        fi
 333        ;;
 334esac